Gecode::Int::Element::ViewDom< VA, VB, VC > Class Template Reference
Other available functionality » Integer propagators

Domain consistent element propagator for array of views. More...

`#include <element.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Perform copying during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
Public Member Functions inherited from Gecode::Int::Element::View< VA, VB, VC, PC_INT_DOM >
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, IdxViewArray< VA > &iv, VB x0, VC x1)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| ViewDom (Space &home, ViewDom &p)
| Constructor for cloning p.
| ViewDom (Home home, IdxViewArray< VA > &iv, VB x0, VC x1)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Int::Element::View< VA, VB, VC, PC_INT_DOM >
| View (Space &home, View &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Additional Inherited Members

Protected Attributes inherited from Gecode::Int::Element::View< VA, VB, VC, PC_INT_DOM >
IdxViewArray< VA > | iv
| Current index-view map.
VB | x0
| View for index.
VC | x1
| View for result.

## Detailed Description

template<class VA, class VB, class VC>
class Gecode::Int::Element::ViewDom< VA, VB, VC >

Domain consistent element propagator for array of views.

The propagator uses staging: first it uses bounds-propagation on the array of views and the uses domain-propagation on the array of views.

Requires

#include <gecode/int/element.hh>
element.hh

Definition at line 262 of file element.hh.

## Constructor & Destructor Documentation

## ViewDom() [1/2]

template<class VA, class VB, class VC>

Gecode::Int::Element::ViewDom< VA, VB, VC >::ViewDom | ( | Space & | home,
|  | ViewDom< VA, VB, VC > & | p )

inline protected

Constructor for cloning p.

Definition at line 383 of file view.hpp.

## ViewDom() [2/2]

template<class VA, class VB, class VC>

Gecode::Int::Element::ViewDom< VA, VB, VC >::ViewDom | ( | Home | home,
|  | IdxViewArray< VA > & | iv,
|  | VB | x0,
|  | VC | x1 )

inline protected

Constructor for creation.

Definition at line 360 of file view.hpp.

## Member Function Documentation

## copy()

template<class VA, class VB, class VC>

Actor * Gecode::Int::Element::ViewDom< VA, VB, VC >::copy | ( | Space & | home | ) |

virtual

Perform copying during cloning.

Implements Gecode::Actor.

Definition at line 388 of file view.hpp.

## cost()

template<class VA, class VB, class VC>

PropCost Gecode::Int::Element::ViewDom< VA, VB, VC >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

If in stage for bounds-propagation defined as low linear, otherwise as high linear.

Reimplemented from Gecode::Int::Element::View< VA, VB, VC, PC_INT_DOM >.

Definition at line 395 of file view.hpp.

## propagate()

template<class VA, class VB, class VC>

ExecStatus Gecode::Int::Element::ViewDom< VA, VB, VC >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 402 of file view.hpp.

## post()

template<class VA, class VB, class VC>

ExecStatus Gecode::Int::Element::ViewDom< VA, VB, VC >::post | ( | Home | home,
|  | IdxViewArray< VA > & | iv,
|  | VB | x0,
|  | VC | x1 )

static

Post propagator for .

Definition at line 366 of file view.hpp.

The documentation for this class was generated from the following files:

- gecode/int/element.hh
- gecode/int/element/view.hpp